//	Dimitrios Milios 932

package genetics;

public class Population {

	private int totalNum;
	private int currentNum;
	FitnessEvaluation fitness;
	private Individual[] pop;
	
	public Population( int totalNum, FitnessEvaluation fitness, SolutionFactory r )
	{
		super();
		this.totalNum = totalNum;
		this.fitness = fitness;
		this.currentNum = totalNum;
		pop = new Individual[totalNum];
		for( int i = 0; i < totalNum; i++ )
			pop[i] = r.create_random_solution();
	}
	
	public void evaluateAll()
	{
		for( int i = 0; i < totalNum; i++ )
			if ( ! pop[i].getEvaluated() )
				fitness.evaluate_solution( pop[i] );
	}
	
	public void add( Individual indiv )
	{
		if ( currentNum < totalNum )
		{
			pop[currentNum] = indiv;
			currentNum++;
		}
	}
	
	public void sortAscending()
	{
		int min;
		int n = totalNum;
		for ( int i = 0; i < n - 1; i++ )
		{
			min = i;
			for ( int j = i + 1; j < n; j++ )
			{
				if ( pop[min].getValue() > pop[j].getValue() )
				{
					Individual tmp1 = pop[j];
					Individual tmp2 = pop[min];
					pop[j] = tmp2;
					pop[min] = tmp1;
				}
			}
		}
	}
	
	public void sortDescending()
	{
		int max;
		int n = totalNum;
		for ( int i = 0; i < n - 1; i++ )
		{
			max = i;
			for ( int j = i + 1; j < n; j++ )
			{
				if ( pop[max].getValue() < pop[j].getValue() )
				{
					Individual tmp1 = pop[j];
					Individual tmp2 = pop[max];
					pop[j] = tmp2;
					pop[max] = tmp1;
				}
			}
		}
	}
	
	public void print()
	{
		for( int i = 0; i < currentNum; i++ )
		{
			pop[i].print();
			System.out.println( "Value: " + pop[i].getValue() );
		}
		System.out.println("---------------------------------");
	}
	
	public double getAvgValue()
	{
		int sum = 0;
		for ( int i = 0; i < totalNum; i++ )
			sum = sum + pop[i].getValue();
		return sum / totalNum ;
	}

	public Individual getMaxIndividual()
	{
		int maxValue = 0;
		Individual maxIndividual = null;
		for ( int i = 0; i < totalNum; i++ )
			if ( maxValue < pop[i].getValue() )
			{
				maxValue = pop[i].getValue();
				maxIndividual = pop[i];
			}				
		return maxIndividual;
	}
	
	public Individual getMinIndividual()
	{
		int minValue = 10000;
		Individual minIndividual = null;
		for ( int i = 0; i < totalNum; i++ )
			if ( minValue > pop[i].getValue() )
			{
				minValue = pop[i].getValue();
				minIndividual = pop[i];
			}
		return minIndividual;
	}

	Individual getIndividualAt( int i )
	{
		return pop[i];
	}
	
	public int getCurrentNum()
	{
		return currentNum;
	}

	public void setCurrentNum(int currentNum)
	{
		this.currentNum = currentNum;
	}

	public int getTotalNum()
	{
		return totalNum;
	}
		
}
