//	Dimitrios Milios 932

package genetics;

import java.util.*;

public class SurvivalSelection implements Selection {

	private Population pop;
	private boolean maxIsBetter = true;
	private ArrayList<String> usedCouples = new ArrayList<String>();
	
	
	public SurvivalSelection( boolean maxIsBetter )
	{
		super();
		this.maxIsBetter = maxIsBetter;
	}
	
	public void preparations()
	{
		usedCouples = new ArrayList<String>();
		selectToLive();
	}
	
	public void selectToLive()
	{
		if ( maxIsBetter )
			pop.sortDescending();
		else
			pop.sortAscending();
		pop.setCurrentNum( pop.getCurrentNum() / 2 );
	}

	public Individual[] findParents()
	{
		Individual[] parents = new Individual[2];
		Random rand = new Random( System.currentTimeMillis() );
		int up_to, i, j;
		do
		{
			up_to = rand.nextInt() % ( pop.getTotalNum() / 2 );
			if ( up_to == 0 ) up_to = 1;
			i = Math.abs( rand.nextInt() % up_to );
			up_to = rand.nextInt() % ( pop.getTotalNum() / 2 );
			if ( up_to == 0 ) up_to = 1;
			j = Math.abs( rand.nextInt() % up_to );
		}
		while( usedCouples.contains( new Integer(i).toString() + "-" + new Integer(j).toString() )
				|| usedCouples.contains( new Integer(j).toString() + "-" + new Integer(i).toString() )
				|| i == j );
		parents[0] = pop.getIndividualAt( i );
		parents[1] = pop.getIndividualAt( j );
		usedCouples.add( new Integer(i).toString() + "-" + new Integer(j).toString() );
		return parents;
	}

	public void setPopulation( Population pop )
	{
		this.pop = pop;
	}

	public boolean isMaxBetter()
	{
		return maxIsBetter;
	}

}
