//	Dimitrios Milios 932

package graphs;

import java.util.*;
import genetics.*;

public class EdgeRecombination implements CrossOver{

	private int chromosomeLenght;
	private Path [] parents = new Path [2];
	private Path child;
	private ListOfLists edgeList;
	
	@SuppressWarnings("unchecked")
	public void setChromosomeLenght( int chromosomeLenght )
	{
		this.chromosomeLenght = chromosomeLenght;
	}

	public Path[] produceChildren( Individual p1, Individual p2 )
	{
		this.parents[0] = ( Path )p1;
		this.parents[1] = ( Path )p2;		
		while( !walkEdgeList() );
		Path children[] = new Path[1];
		children[0] = child;
		return children;
	}
	
	private void createEdgeList()
	{
		edgeList = new ListOfLists( chromosomeLenght );
		int neighbours[] = new int [4];
		int nodePos;
		for( int currNode = 0; currNode < chromosomeLenght; currNode++ )
		{
			LinkedList<Integer> list = new LinkedList<Integer>();
			
			nodePos = parents[0].getPositionOfNode( currNode );			
			neighbours[0] =  parents[0].getNodeAtPosition( ( nodePos + 1 ) % chromosomeLenght );
			if( nodePos != 0 )
				neighbours[1] =  parents[0].getNodeAtPosition( nodePos - 1 );
			else
				neighbours[1] =  parents[0].getNodeAtPosition( chromosomeLenght - 1 );
			
			nodePos = parents[1].getPositionOfNode( currNode );
			neighbours[2] =  parents[1].getNodeAtPosition( ( nodePos + 1 ) % chromosomeLenght );
			if( nodePos != 0 )
				neighbours[3] =  parents[1].getNodeAtPosition( nodePos - 1 );
			else
				neighbours[3] =  parents[1].getNodeAtPosition( chromosomeLenght - 1 );
				
			for( int k = 0; k < 4; k++ )
				if( !list.contains( neighbours[k] ) )
					list.add( neighbours[k] );
			edgeList.addListAt( list, currNode );
		}
	}
	
	private boolean walkEdgeList()
	{
		this.createEdgeList();
		child = new Path( chromosomeLenght );
		int currentNode = edgeList.indexOfSmallerList();
		LinkedList <Integer>neighbours = edgeList.getListAt( currentNode );
		child.addNode( currentNode );
		for( int i = 1; i < chromosomeLenght; i++ )
		{
			edgeList.deleteFromAll( currentNode );
			switch( neighbours.size() )
			{
			case 1:
				currentNode = neighbours.getFirst();
				neighbours = edgeList.getListAt( currentNode );
				child.addNode( currentNode );
				break;
			case 2:
				currentNode = edgeList.indexOfSmallerList( neighbours.get(0), neighbours.get(1) );
				neighbours = edgeList.getListAt( currentNode );
				child.addNode( currentNode );
				break;
			case 3:
				currentNode = edgeList.indexOfSmallerList( neighbours.get(0), neighbours.get(1), neighbours.get(2) );
				neighbours = edgeList.getListAt( currentNode );
				child.addNode( currentNode );
				break;
			case 4:
				currentNode = edgeList.indexOfSmallerList( neighbours.get(0), neighbours.get(1), neighbours.get(2), neighbours.get(3) );
				neighbours = edgeList.getListAt( currentNode );
				child.addNode( currentNode );
				break;
			default:
				return false;
			}
		}
		return true;
	}
	
}
