//	Dimitrios Milios 932

package graphs;
import genetics.FitnessEvaluation;
import genetics.Individual;
import genetics.SolutionFactory;

import java.io.*;
import java.util.Random;

public class Graph implements FitnessEvaluation, SolutionFactory{

	private String[][] graph_array;

	private int nodes = 0;
	private int chromosomeLenght;

	public Individual create_random_solution()
	{
		Path randomPath = new Path(nodes);
		Random rand = new Random(System.nanoTime());
		int candidateNode;
		int prevNode;
		randomPath.addNode(prevNode = Math.abs(rand.nextInt() % nodes)); // starting
																			// point
		for (int i = 0; i < nodes - 1; i++)
		{
			while (randomPath.checkForNode(candidateNode = Math.abs(rand.nextInt() % nodes))
					|| graph_array[prevNode][candidateNode] == "0");
			randomPath.addNode(candidateNode);
			randomPath.addWeight(graph_array[prevNode][candidateNode]);
			prevNode = candidateNode;
		}
		randomPath.setEvaluated( true );
		return randomPath;
	}

	public void evaluate_solution( Individual e_path0 )
	{
		Path e_path = (Path) e_path0;
		int nextNode;
		int prevNode = e_path.getNodeAtPosition( 0 );
		for (int index = 1; index < nodes; index++)
		{
			nextNode = e_path.getNodeAtPosition( index );
			e_path.addWeight( graph_array[prevNode][nextNode] );
			prevNode = nextNode;
		}
		e_path0.setEvaluated( true );
	}
	
	public void read_from_file(String file_name) throws IOException
	{
		FileReader input_file = new FileReader(file_name);
		LineNumberReader in = new LineNumberReader(input_file);
		nodes = compute_number_of_nodes(file_name);

		graph_array = new String[nodes][nodes];
		for (int i = 0; i < nodes; i++)
			for (int j = i; j < nodes; j++)
				if (i != j)
				{
					graph_array[i][j] = in.readLine();
					graph_array[j][i] = graph_array[i][j];
				} else
					graph_array[i][j] = "0";
		chromosomeLenght = nodes;
	}
	

	private int compute_number_of_nodes(String file_name) throws IOException
	{
		int lines = 0;
		int count = 1;
		int i;
		FileReader input_file = new FileReader(file_name);
		LineNumberReader in = new LineNumberReader(input_file);
		while (in.readLine() != null)
			lines++;
		for (i = 1; i <= lines; i = i + count)
			count++;
		if (i != lines + count)
		{
			System.out.println("Error: Wrong input");
			System.exit(0);
		}
		return count;
	}
	

	public void print()
	{
		System.out.println( "\n\nArray Representation of the Graph" );
		for (int i = 0; i < nodes; i++)
			System.out.print( "\tedge" + i );
		System.out.println();
		for (int i = 0; i < nodes; i++)
		{
			System.out.print( "edge" + i + ":\t" );
			for (int j = 0; j < nodes; j++)
			{
				System.out.print(graph_array[i][j]);
				System.out.print('\t');
			}
			System.out.println();
		}
	}

	public int getChromosomeLenght()
	{
		return chromosomeLenght;
	}

}
