//	Dimitrios Milios 932

package graphs;
import java.util.*;


public class ListOfLists {

	private int lenght;
	private LinkedList<Integer>[] theList;
	
	@SuppressWarnings("unchecked")
	public ListOfLists( int chromosomeLenght )
	{
		lenght = chromosomeLenght;
		theList = new LinkedList[chromosomeLenght];
		for( int i = 0; i < chromosomeLenght; i++ )
			theList[i] = new LinkedList<Integer>();
	}
	
	public void addListAt( LinkedList<Integer> list, int j )
	{			
		theList[j] = list;
	}
	
	public int indexOfSmallerList()
	{
		int min = 10000;
		int curr = 0;
		for( int i = 0; i < lenght; i++ )
			if ( theList[i].size() < min )
			{
				min = theList[i].size();
				curr = i;
			}
		return curr;
	}
	
	public int indexOfSmallerList( int i1, int i2 )
	{
		Random rand = new Random( System.currentTimeMillis() );
		if ( theList[i1].size() < theList[i1].size() )
			return i1;
		if ( theList[i1].size() > theList[i1].size() )
			return i2;
		if ( ( Math.abs( rand.nextInt() ) ) % 2 == 0 )
			return i1;
		return i2;
	}
	
	public int indexOfSmallerList( int i1, int i2, int i3 )
	{
		int first_result = indexOfSmallerList( i1, i2 );
		return indexOfSmallerList( first_result, i3 );
	}
	
	public int indexOfSmallerList( int i1, int i2, int i3, int i4 )
	{
		int first_result = indexOfSmallerList( i1, i2 );
		int second_result = indexOfSmallerList( i3, i4 );
		return indexOfSmallerList( first_result, second_result );
	}
	
	public void deleteFromAll( int target )
	{
		Integer t = new Integer( target );
		for( int i = 0; i < lenght; i++ )
			if ( theList[i].contains( t ) )
				theList[i].remove( t );
	}
	
	public LinkedList<Integer> getListAt( int i )
	{
		return theList[i];
	}
	
}
