//	Dimitrios Milios 932

package graphs;
import genetics.Individual;

import java.util.*;


public class Path implements Individual {

	private int chromosomeLength;
	private boolean evaluated = false;
	private ArrayList<Integer> path;
	private ArrayList<String> weight_of_edges;
	
	
	public Path( int nodes )
	{
		this.chromosomeLength = nodes;
		this.path = new ArrayList<Integer>( nodes );
		this.weight_of_edges = new ArrayList<String>( nodes - 1 );
	}
	
	public void addNode( int i )
	{
		path.add( new Integer( i ) );
	}
	
	public int getNodeAtPosition( int i )
	{
		return path.get( i );
	}
	
	public int getPositionOfNode( int node )
	{
		for( int i = 0; i < chromosomeLength; i++ )
			if ( path.get( i ) == node )
				return i;
		return 0;
	}
	
	public void addWeight( String w )
	{
		weight_of_edges.add( w );
	}
	
	
	public boolean checkForNode( int node )
	{
		if ( path.contains( new Integer( node ) ) )
			return true;
		return false;
	}
	
	
	public int totalWeight()
	{
		int total = 0;
		for ( int i = 0; i < weight_of_edges.size(); i++ )
			total = total + Integer.parseInt( ( String )weight_of_edges.get( i ) );
		return total;
	}
	
	public int getValue()
	{
		return totalWeight();
	}
	
	public void print()
	{
		System.out.println('\n');
		System.out.println( "\tNodes\tWeights" );
		for( int i = 0; i < path.size(); i++ )
		{
			if ( i > 0 )
				System.out.println( "\t-\t" + weight_of_edges.get( i - 1 ) );
			System.out.println( "\t" + path.get( i ) );
		}
		System.out.println();
	}

	
	public int size()
	{
		return chromosomeLength;
	}

	public boolean getEvaluated()
	{
		return  evaluated;
	}

	public void setEvaluated( boolean b )
	{
		 evaluated = b;
		
	}
	
}
