//	Dimitrios Milios 932

package graphs;
import genetics.*;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;


public class TSPGenetic
{
	public static void main(String[] args) throws IOException
	{		
		Graph our_graph = new Graph();
		EdgeRecombination cr = new EdgeRecombination();
		SurvivalSelection sel = new SurvivalSelection( false );
		
		System.out.println( "Dimitrios Milios 932" );
		System.out.println( "The TSP Genetics Project\n" );
		int populationSize = get_number( "Give the size of the population: " );
		int generations = get_number( "Give the number of generations: " );
		our_graph.read_from_file( get_file_name() );
		our_graph.print();
		
		GeneticAlgorithm genetic = new GeneticAlgorithm( cr, our_graph, our_graph, sel );
		genetic.execute( populationSize, generations );
	}
	
	public static String get_file_name() throws IOException
	{
		String file_name;
		File f;
		do
		{
			System.out.print("Type the name of the input file: ");
			BufferedReader br = new BufferedReader( new InputStreamReader( System.in ) );
			file_name = new String( br.readLine() );
			f = new File( file_name );
			if ( !f.exists() || !f.isFile() )
				System.out.println("Error: No such file exist! ");
		}
		while ( !f.isFile() );
		return file_name;
	}

	public static int get_number( String text ) throws IOException
	{
		int number = 0;
		String input;
		boolean ask_again;
		do
		{
			 ask_again = false;
			 System.out.print( text );
			 BufferedReader br = new BufferedReader( new InputStreamReader( System.in ) );
			 input = new String( br.readLine() );
			 if ( !input.matches( "[0-9]*" )
					 || Integer.parseInt( input ) <= 0 )
			 {
				 System.out.println( "Error: Invalid input!" );
				 ask_again = true;
			 }
			 else
				 number = Integer.parseInt( input );
		}
		while( ask_again );
		return number;
	}
	
}
